#!/bin/sh 
# /root/my-applications/bin/cache-fen3.sh ("Homme fort" / "Strong Man") 

# # Objectif : icnifier ou masquer les fentres ouvertes sur un bureau 
 # quand on se sert d'un gest. de fen. qui n'a pas cette fonction. / 
# # Purpose: iconify or shade windows open on a desktop when using a 
 # window manager that does not have that function. 

# # Requires / Requiert : wmctrl (http://tomas.styblo.name/wmctrl/) 

# # (c) Christian L'cuyer (alias / aka musher0), Gatineau (Qc), Canada, 
 # 25 mai / May 25, 2014. Tous droits rservs / All rights reserved.
 # Edited / Rvis 26 et 27 mai 2014 / May 26 & 27, 2014 par CL.
#### 

a="hidden" 
# Please note that on some wm's, this really means "hidden", not 
# just "iconified"... 
# a="shaded" 
 # Le paramtre "shaded" ne performe pas toujours aussi bien : il peut 
 # ignorer certaines fentres, telle l'Analog-Clock de GTK-Basic. /  
 # The "shaded" setting doesn't always perform as well: it may ignore 
 # some windows, such as GTK-Basic's Analog-Clock. 

bur="`wmctrl -d | awk '$2 == "*" { print $1 }'`"  
 # Dit sur quel bureau nous sommes. / Says on which desktop we are. 
 # ( +/- tir du script de kittykat. Le reste est de moi.) / 
 # (Line from kittykat's script +/- verbatim. The rest is from me.) 

for i in `wmctrl -l | grep -v '+AT' | awk -v bur=$bur '$2 == bur || $2 == -1 { print $NF }'` 
 # Ci-dessus / Above, < ... || $2 == -1 ... > 
 # ramasse aussi les fentres "collantes". / also picks up sticky windows. 
 # Les fentres de ROX-Filer avec "+AT" dans sont traits ci-dessous. /
 # The ROX-Filer windows with "+AT" in the title are processed below.
 do 
	wmctrl -r "$i" -b toggle,$a
 done

# Vrifions maintenant les dossiers ouverts de ROX-Filer. / We now check for open ROX-Filer folders.
wmctrl -l | grep '+AT' | awk -v bur=$bur '$2 == bur || $2 == -1 { print $(NF-1)" "$NF }' | tr "\n" ";" > /tmp/rxflr
nchamps="`wmctrl -l | awk '$NF ~ /\+AT/ { print $(NF-1)" "$NF }' | wc -l`"
for i in `seq $nchamps`
do
	wmctrl -r "`awk -F";" -v i=$i '{ print $i }' /tmp/rxflr`" -b toggle,$a
done
rm -f /tmp/rxflr
# Le cas de / Geany's / case ! # Ses fentres secondaires / Its secondary windows.
[ "`wmctrl -l | awk '$NF ~ /Find/'`" ] && wmctrl -r "Find" -b toggle,$a
[ "`wmctrl -l | awk '$NF ~ /Replace/'`" ] && wmctrl -r "Replace" -b toggle,$a
